    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * ColorWriteHandler.java
    029     * ----------------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: ColorWriteHandler.java,v 1.3 2005/10/18 13:35:21 mungady Exp $
    036     *
    037     * Changes (from 23-Dec-2003)
    038     * --------------------------
    039     * 23-Dec-2003 : Added standard header and Javadocs (DG);
    040     *
    041     */
    042
    043    package org.jfree.xml.writer.coretypes;
    044
    045    import java.awt.Color;
    046    import java.io.IOException;
    047
    048    import org.jfree.xml.writer.AbstractXmlWriteHandler;
    049    import org.jfree.xml.writer.AttributeList;
    050    import org.jfree.xml.writer.XMLWriter;
    051    import org.jfree.xml.writer.XMLWriterException;
    052
    053    /**
    054     * A handler for writing a {@link Color} object.
    055     */
    056    public class ColorWriteHandler extends AbstractXmlWriteHandler  {
    057
    058        /**
    059         * Default constructor.
    060         */
    061        public ColorWriteHandler() {
    062            super();
    063        }
    064
    065        /**
    066         * Performs the writing of a {@link Color} object.
    067         *
    068         * @param tagName  the tag name.
    069         * @param object  the {@link Color} object.
    070         * @param writer  the writer.
    071         * @param mPlexAttribute  ??.
    072         * @param mPlexValue  ??.
    073         *
    074         * @throws IOException if there is an I/O error.
    075         * @throws XMLWriterException if there is a writer error.
    076         */
    077        public void write(final String tagName, final Object object, final XMLWriter writer,
    078                          final String mPlexAttribute, final String mPlexValue)
    079            throws IOException, XMLWriterException {
    080            final Color color = (Color) object;
    081            final AttributeList attribs = new AttributeList();
    082            if (mPlexAttribute != null) {
    083                attribs.setAttribute(mPlexAttribute, mPlexValue);
    084            }
    085            attribs.setAttribute("value", encodeColor(color));
    086            if (color.getAlpha() != 255) {
    087                attribs.setAttribute("alpha", String.valueOf(color.getAlpha()));
    088            }
    089            writer.writeTag(tagName, attribs, true);
    090        }
    091
    092        private String encodeColor(final Color color) {
    093            return "#" + encodeInt(color.getRed())
    094                + encodeInt(color.getGreen()) + encodeInt(color.getBlue());
    095        }
    096
    097        private String encodeInt(final int i) {
    098            final String retVal = Integer.toHexString(i);
    099            if (retVal.length() == 1) {
    100                return "0" + retVal;
    101            }
    102            else {
    103                return retVal;
    104            }
    105        }
    106    }